# -*- coding: utf-8 -*-
from Plugins.Bp.geminimain.gLocale import _
from Plugins.Bp.geminimain.GeminiDef import *

from Plugins.Bp.geminimain.gTools import libgeminimain, cleanexit, pathExists, pathRemove, gLoadPixmap, WebPicLoad, gPluginPath, mylog
from Plugins.Bp.geminimain.WidgetConfig import gConfigWindow, gConfigSelection, gConfigOnOff, gConfigDirectory, CONFIGSEPERATOR

from Plugins.Bp.geminimain.lib.libjukebox import Cjukebox
from Plugins.Bp.geminimain.Cjukeboxevent import cjukeboxevent
from Plugins.Bp.geminimain.WidgetVariableList import WidgetVariableList
from Plugins.Bp.geminimain.WidgetBackGround import WidgetBackground, confBackground
from Plugins.Bp.geminimain.plugin import cgevent, dbusNotifier, geventNotifier
from Plugins.Bp.geminimain.FileBrowser import *
from Plugins.Bp.geminimain.ThumbView import soundmenu, sortmenu

from enigma import eTimer, eServiceReference, eActionMap, ePicLoad
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import NumberActionMap, ActionMap
from Screens.ChoiceBox import ChoiceBox
from Components.config import config, NoSave, getConfigListEntry, ConfigText, ConfigInteger
from Components.Console import Console
from Components.Label import Label
from Components.Pixmap import MultiPixmap
from Components.Sources.StaticText import StaticText
from Components.Sources.Progress import Progress
from Components.AVSwitch import AVSwitch

from skin import loadSkin
loadSkin(gPluginPath + "geminijukebox/skin.xml")

from os import path as os_path, remove as os_remove, walk as os_walk
import hashlib
from sys import getsizeof as sys_getsizeof

from Plugins.Bp.geminimain.equalizer import Cequalizer
	
class JukeBoxSummary(Screen):
	def __init__(self, session, parent):
		Screen.__init__(self, session, parent = parent)
		self.skinName = ["Jukebox_Summary"]

class JukeBoxSummarySupport:
	def __init__(self):
		pass

	def createSummary(self):
		return JukeBoxSummary

#----------------------------------------------------------------------------------------
EqualizerDefaultValue = "24,24,24,24,24,24,24,24,24,24"

class JukeBox(JukeBoxSummarySupport, WidgetVariableList):
	#Status und Pixmap
	STAT_STOP=0
	STAT_PLAY=1
	STAT_PAUSE=2
	STAT_REV=3
	STAT_FF=4
	#Picture
	#noCover = gLoadPixmap("geminijukebox/icon_noCover.png")
	#dirPic = gLoadPixmap("geminijukebox/folder.png")
	backPic = gLoadPixmap("bigext_back.png")
	dirPic = gLoadPixmap("bigext_folder_music.png")
	noCover = gLoadPixmap("bigext_music.png")
	plPic = gLoadPixmap("bigext_playlist.png")
	wwwPic = gLoadPixmap("bigext_www.png")
	

	ALLOW_SUSPEND = True
	ENABLE_RESUME_SUPPORT = True

	def __init__(self, session, name=None, setPath=None):
		WidgetVariableList.__init__ (self, session, _("Jukebox"), icon="geminijukebox/icon_jukebox.png", LinesProEntry=4, ListIcon=(100,100), showMenuPix=True, NameRed=_("Rewind"), NameGreen=_("Play"), NameYellow=_("Pause / Resume"), NameBlue=_("Forward"))
		self.skinName = ["Jukebox-HD", "Jukebox"]
			
		self["TimeStr"] = StaticText()
		self["NameStr"] = StaticText()
		self["Progress"] = Progress()
		self["StatusPixmap"] = MultiPixmap()
		self["LoopPixmap"] = MultiPixmap()
		self["RandomPixmap"] = MultiPixmap()
		self["ScanPixmap"] = MultiPixmap()
		self["TitleStr"] = StaticText(_("Title") + ": ")
		
		from Plugins.Bp.geminimain.plugin import cgevent, dbusNotifier, geventNotifier
		self.__readConfig(setup=False)
		
		self.__isplaying = False
		self.__render = False
		self.__filling = True
		self.__Playlisttyp = None
		self.__currentPage = 0
		
		if setPath==None:
			startdir = cgevent.getConfig("Jukebox_StartDir"," ")
			lastpath = cgevent.getConfig("Jukebox_lastpath","/media/")
			if startdir != " " and pathExists(startdir):
				self.path=startdir + "/.."
			elif pathExists(lastpath):
				self.path=lastpath
			else:
				self.path = "/media/"
		else:
			self.path = setPath
			
		if self.path == "":
			self.path = "/media/"
			
		extension = self.path.split('.')
		extension = extension[-1].upper()
		if extension == "M3U" or extension == "PLS":
			self.__Playlisttyp = extension
			self.lastpath = os_path.dirname(self.path)
		else:
			self.lastpath = self.path
			self.path = os_path.dirname(self.path)
			
		self.__hidelist, self.__permlist = readDMconf()
		
		#self.Console = Console()

		from Plugins.Bp.geminimain.lib import libgtools
		self.libgtools = libgtools
		
		self.__libjukebox = Cjukebox()
		self.__libjukebox.callback = self.__newPlayerEvent
		
		self.picLoads = {}
		self.webPictures = {}
		self.__Pictures = [] #test
		self.__WebPictures = [] #test
		
		self.__ThumbTimer = eTimer()
		self.__ThumbTimer_conn = self.__ThumbTimer.timeout.connect(self.__doRender)

		JukeBoxSummarySupport.__init__(self)
		
		self.__CurrDevice = "hw:0,0"
		for x in self.libgtools.getAudioDevice():
			if x[2]=="BCM ALSA driver - BCM PCM":
				self.__CurrDevice = x[1]
		self.__DMMAlsaDevice = self.__CurrDevice

		self.__currRunning = None
		self.__firstTitle = ""
		self.__randomOn = 0
		self.__loop = 0
		self.lastService = self.session.nav.getCurrentlyPlayingServiceReference()
		self.session.nav.stopService()
		self.Background = self.session.instantiateDialog(WidgetBackground, self)
		
		self["NumberActions"] = NumberActionMap(["NumberActions", "InputAsciiActions"],
		{
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
		}, -2)
		
		self["jbactions"] = ActionMap(["gActions"],
		{
			"nextBouquet": self.nextTitle,
			"prevBouquet": self.prevTitle,
			"historyBack": self.historyBack,
			"historyNext": self.historyNext
		}, -2)
		
		geventNotifier.append((EVENT_QBCALLBACK, self.__callbackQB))
		self.__slot = eActionMap.getInstance().bindAction('', -0x1FFFFFFF, self.__keyPressed)
		self.onLayoutFinish.append(self.__LayoutFinish)
		self.onShown.append(self.__Shown)
		return
		
	def __Shown(self):
		if not pathExists(self.path):
			self.session.open(MessageBox, _("file not found: ") + self.path, MessageBox.TYPE_ERROR, timeout=5)
			self.__slot = None
			geventNotifier.remove((EVENT_QBCALLBACK, self.__callbackQB))
			self.Background.Exit()
		
			#if self.Console is not None:
			#	if len(self.Console.appContainers):
			#		for name in self.Console.appContainers.keys():
			#			self.Console.kill(name)
			self.__ThumbTimer.stop()
			del self.__ThumbTimer
			del self.__libjukebox
			cjukeboxevent.clean()
			del self.libgtools
			self.session.nav.playService(self.lastService)
			self.close()
			cleanexit(__name__)
			return
		self.__fillListe()
		
	def __LayoutFinish(self):
		self.__sc = AVSwitch().getFramebufferScale()
		self.__iconSize = self.getListIcon()
		#self.__fillListe()
		
	def KeyExit(self):
		self.__slot = None
		geventNotifier.remove((EVENT_QBCALLBACK, self.__callbackQB))
		self.Background.Exit()
		self.__saveLastPath()
		
		#if self.Console is not None:
		#	if len(self.Console.appContainers):
		#		for name in self.Console.appContainers.keys():
		#			self.Console.kill(name)
		self.__ThumbTimer.stop()
		del self.__ThumbTimer
		self.webPictures.clear()
		self.picLoads.clear()
		self.SetList()
		self.__libjukebox.stop()
		del self.__libjukebox
		cjukeboxevent.clean()
		del self.libgtools
		self.session.nav.playService(self.lastService)
		self.close()
		cleanexit(__name__)
		
	def __keyPressed(self, key=None, flag=None):
		if flag is not None and flag==1:
			if key==128:#stop
				self.__firstTitle = ""
				self.__libjukebox.stop()
			elif key==207:#pause
				self.KeyYellow()
			elif key==113 and self.__CurrDevice != self.__DMMAlsaDevice:#mute
				self.__libjukebox.mute()
			elif key==114 and self.__CurrDevice != self.__DMMAlsaDevice:#volume-
				self.__libjukebox.setVolume("-")
			elif key==115 and self.__CurrDevice != self.__DMMAlsaDevice:#volume+
				self.__libjukebox.setVolume("+")
		return 0

	def __newPlayerEvent(self, func, value):
		#mylog(self,self.__newPlayerEvent.__name__, func, value)
		if func == cjukeboxevent.JUKEBOX_STATUS:
			if value=="PAUSED":
				self["StatusPixmap"].setPixmapNum(self.STAT_PAUSE)
			elif value=="PLAYING":
				self["StatusPixmap"].setPixmapNum(self.STAT_PLAY)
				self.__isplaying = True
			elif value=="EOF":
				sel = self.getCurrentEntry()
				if self.__currRunning is not None and sel and  self.__currRunning != sel and sel[3][B_FILTER] & FILTER_SOUND:
					self.__playFile()
					return
				self.nextTitle()
			elif value=="STOPPED":
				self.__isplaying = False
				self.__stopFile()
				self.Background.setHideTimerWaitPlugin()
				
			elif value=="SEEKFF":
				self["StatusPixmap"].setPixmapNum(self.STAT_FF)
			elif value=="SEEKREV":
				self["StatusPixmap"].setPixmapNum(self.STAT_REV)
		elif func == cjukeboxevent.JUKEBOX_TIME_URL:
			val = value.split(' ',2)
			if len(val)==3:
				#state = int(val[0])
				totaltime = int(val[0])
				playtime = int(val[1])
				
				if self.__currRunning is None:
					self.__searchCurrRunning(val[2],False)
					self.__setNameStr()
					
				if totaltime > 0 and playtime >= 0:
					prozvalue = playtime*100/totaltime
					if prozvalue >= 0 and prozvalue <= 100:
						self["Progress"].setValue(prozvalue)
						if self.__timeInvers == 1:
							self["TimeStr"].setText("-"+libgeminimain.getHumanDate(1,totaltime - playtime))
						else:
							self["TimeStr"].setText(libgeminimain.getHumanDate(1,playtime))
						return
			self["Progress"].setValue(0)
			self["TimeStr"].setText("")
		elif func == cjukeboxevent.JUKEBOX_ERROR:
			self.Background.lockKeys(True)
			self.session.openWithCallback(self.__callbackQB, MessageBox, value, MessageBox.TYPE_INFO, timeout = 5)
			
	def getRenderState(self):
		return self.__render
	
	def getPlayState(self):
		return self.__isplaying
			
	def __doRender(self, val=None, *args):
		mylog(self, self.__doRender.__name__, "start")
		if self.show and not self.Background.getRenderState():
			self.renderPage()
		else:
			self.__render = False
			self.__ThumbTimer.start(500, True)

	def toggleShowHide(self,val):
		if val == True and self.shown:
			self.hide()
		else:
			self.show()
			
	def __searchCurrRunning(self, filename, setIndex):
		count=0
		for x in self.GetList():
			if x[3][B_FULL] == filename:
				if setIndex:
					self.SetIndex(count)
				self.__currRunning = self.getCurrentEntry()
				break
			count+=1
			
	def KeyLeft(self):
		if self.shown:
			WidgetVariableList.KeyLeft(self)
		else:
			self.Background.PipPrevService()
		
	def KeyRight(self):
		if self.shown:
			WidgetVariableList.KeyRight(self)
		else:
			self.Background.PipNextService()
	
	def keyNumberGlobal(self, number):
		if self.shown == False:
			self.Background.keyNumberGlobal(number)
			
	def cleanName(self, str):
		str.replace("/","") #valid_chars)
		str.strip()
		return str
		
	def __fillListe(self):
		mylog(self,self.__fillListe.__name__, "start")
		self.__filling = True
		self.__ThumbTimer.stop()
		self.__Pictures = [] #test
		self.__WebPictures = [] #test
		self.webPictures.clear()
		self.picLoads.clear()
		self.SetList()
		m = hashlib.md5()
		m.update(self.path)
		self.__checksum = int(m.hexdigest(),16)
		
		self["ScanPixmap"].setPixmapNum(1)
		llist = []
		index = 0
		count = 0
		sortby = cgevent.getConfig("Jukebox_sort", SORT_NAME)
		if self.__randomOn:
			sortby = SORT_RANDOM
		
		if self.__Playlisttyp is not None:
			flist = libgeminimain.getPyList(GETPLAYLIST,(self.path, self.lastpath, self.__Playlisttyp, FILTER_SOUND))
		else:
			flist = libgeminimain.getPyList(GETFILELIST,(self.path, (FILTER_SOUND | FILTER_PL), sortby, 0,0,0))
			
		for mfile in flist:
			pic = None
			taglist = []
			#mfile[B_STATUS] = 0
			
			if mfile[B_NAME] in self.__hidelist:
				continue
			elif mfile[B_FILTER] & FILTER_SOUND:
				pic = None
				if self.__Playlisttyp is not None:
					mfile[B_TOTALTIME], mfile[B_TITLE], mfile[B_ARTIST], mfile[B_ALBUM], mfile[B_GENRE], mfile[B_RELEASE] = self.libgtools.SoundInfos(mfile[B_FULL])
				taglist = [ mfile[B_TOTALTIME], mfile[B_TITLE], mfile[B_ARTIST], mfile[B_ALBUM], mfile[B_GENRE], mfile[B_RELEASE], mfile[B_FULL] ]
			
			elif mfile[B_FILTER] & FILTER_GOUP:
				pic = self.backPic
			elif mfile[B_FILTER] &  FILTER_PL:
				pic = self.plPic
			elif mfile[B_FILTER] & FILTER_DIR:
				pic = self.dirPic
			elif mfile[B_FILTER] & FILTER_WEB:
				pic = self.wwwPic
				
			llist.append((createInfoString(taglist, mfile), pic, None, mfile, taglist))
			
			if mfile[B_FULL] == self.lastpath:
				index = count
			count += 1

		self.setTitle(_("Path") + ": " + self.path + " (" + str(count) +")")
		self.SetList(llist)
		self.SetIndex(index)
		self.__currentPage = -1
		self.__filling = False
		self.selectionChanged()
		
	def selectionChanged(self):
		if self.__filling:
			mylog(self, self.selectionChanged.__name__, "stop - FILLING LIST!!")
			return
		if self.__currentPage != self.GetPageIndex():
			mylog(self, self.selectionChanged.__name__, "update page")
			self.__doRender()

	def renderPage(self):
		self.__currentPage = self.GetPageIndex()
		self.__Pictures = []
		#self.__WebPictures = []
		folderCover = None
		count = self.GetPageDivider() * self.GetPageIndex()
		if self.__Playlisttyp is None:
			coverFileNames = ["cover.jpg", "Cover.jpg", "folder.jpg", "Folder.jpg"]
			for name in coverFileNames:
				cover = self.path + "/" + name
				if pathExists(cover):
					folderCover = cover
					break
				
		for x in self.GetPageContent():
			if x[1] == None:
				mylog(self, self.renderPage.__name__, "Entry: %d" %count)
				mfile = x[3]
				file = None
				coverFileNames = []
				
				if folderCover is not None:
					exists=False
					for p in self.__Pictures:
						if p[1] == folderCover:
							p[2].insert(0,count)
							exists=True
							break
							
					if not exists:
						self.__Pictures.insert(0, [os_path.basename(mfile[B_CFILE]),
							folderCover,
							[count],
							self.__checksum])
						
				else:
					
					if self.__Playlisttyp is not None:
						coverFileNames = ["cover.jpg", "Cover.jpg", "folder.jpg", "Folder.jpg"]
					
					if mfile[B_ARTIST] != "" and mfile[B_ALBUM] != "":
						coverFileName = self.cleanName(mfile[B_ARTIST]) + "-" + self.cleanName(mfile[B_ALBUM]) + ".jpg"
						coverFileNames.append(coverFileName)
					
					tryWeb=True
					path = os_path.dirname(mfile[B_FULL]) + "/"
					for name in coverFileNames:
						cover = path + name
						if pathExists(cover):
							size = os_path.getsize(cover)
							if size < 1000: # keiner 1000B
								tryWeb=False
								mylog(self, self.renderPage.__name__, "do not show %s size %dB is to small" %(name ,size))
							else:
								file = cover
							break
						
					if file is not None:
						exists=False
						for p in self.__Pictures:
							if p[1] == file:
								p[2].insert(0,count)
								exists=True
								break
							
						if not exists:
							self.__Pictures.insert(0, [os_path.basename(mfile[B_CFILE]),
								file,
								[count],
								self.__checksum])
						
					elif self.__useInetPicture and tryWeb and not pathExists(mfile[B_CFILE] + "_nopic.txt") and mfile[B_ARTIST] != "" and mfile[B_ALBUM] != "":
						mylog(self, self.renderPage.__name__, "check webload...")
						#webload
						exists=False
						file = path + coverFileName
						for w in self.__WebPictures:
							if w[1] == file:
								w[2].insert(0,count)
								exists=True
								break
						if not exists: #id, jpgfile, indices, cache, file,  filter
							self.__WebPictures.insert( 0,[ os_path.basename(mfile[B_CFILE]), file, [count], mfile[B_CFILE], mfile[B_FULL], mfile[B_FILTER], self.__checksum ] )
					else:
						
						entry = self.GetList()[count]
						self.editEntry(count, (entry[0], self.noCover) + entry[2:])
			count += 1
			
		self.startPicload()
		self.startWebLoad()
			
	def __createEntryList(self, entr, pic=None):
		if pic is None:
			pic = self.noCover
		taglist = entr[4]
		if taglist is None:
			taglist = entr[4]
		elif taglist != []:
			taglist.append(entr[3][B_FULL])
			#print "______________taglist",taglist
		return (createInfoString(taglist, entr[3]), pic, None, entr[3], taglist)

	def startWebLoad(self):
		if self.__WebPictures != []:
			mylog(self, self.startWebLoad.__name__, "start")
			task = self.__WebPictures.pop()
			self.__setWebLoad(task[0], task[1], task[2], task[3], task[4], task[5], task[6])
		else:
			mylog(self, self.startWebLoad.__name__, "all loaded :-)")
	
	def __setWebLoad(self, id, jpgfile, indices, cache, file, filter, checksum):
		# prüfen ob bild schreiben/lesen/löschen sperren
		# bild anmelden
		self["ScanPixmap"].setPixmapNum(1)
		self.webPictures[id] = WebPicLoad()
		self.webPictures[id].callback = boundFunction(self.__callbackWebPicture, id)
		self.webPictures[id].indices = indices
		self.webPictures[id].jpgfile = jpgfile
		self.webPictures[id].checksum = checksum
		self.webPictures[id].startSound(file, cache, filter)
		
	def __callbackWebPicture(self, id, *val):
		#print "__________________callbackWebLoad",id, val, self.webPictures[id]
		if pathExists(self.webPictures[id].jpgfile) and not self.webPictures[id].checksum - self.__checksum:
			self.__setPicload(id, self.webPictures[id].jpgfile, self.webPictures[id].indices, self.webPictures[id].checksum)
		else:
			for i in self.webPictures[id].indices:
				self.editEntry(i, self.__createEntryList(self.GetList()[i], self.noCover))
				
		self.webPictures[id].delete()
		self["ScanPixmap"].setPixmapNum(0)
		self.startWebLoad()
		
	def startPicload(self):
		if self.__Pictures != []:
			mylog(self, self.startPicload.__name__, "start")
			self.__render = True
			
			mp = 4
			if len(self.__Pictures) < mp:
				mp = len(self.__Pictures)
			
			for i in range(mp):
				task = self.__Pictures.pop()
				self.__setPicload(task[0], task[1], task[2], task[3])
			
		else:
			mylog(self, self.startPicload.__name__, "all loaded :-)")
			self.__render = False
			self["ScanPixmap"].setPixmapNum(0)
			
	def __setPicload(self, id, file, indices, checksum):
		### current self.path!
		self["ScanPixmap"].setPixmapNum(1)
		if os_path.getsize(file) < 1000:
			for i in indices:
				if not checksum - self.__checksum:
					self.editEntry(i, self.__createEntryList(self.GetList()[i], self.noCover))
			return
		self.__render = True
		self.picLoads[id] = ePicLoad()
		self.picLoads[id].conn = self.picLoads[id].PictureData.connect(boundFunction(self.__callbackDecode, id))
		self.picLoads[id].indices = indices
		self.picLoads[id].setPara((self.__iconSize[0], self.__iconSize[1], self.__sc[0], self.__sc[1], self.__cache, 2, "#00000000"))
		self.picLoads[id].jpgfile = file
		self.picLoads[id].checksum = checksum
		#self.picLoads[id].startDecode(file)
		self.picLoads[id].getThumbnail(file)
	
	def __callbackDecode(self,id,info):
		#print "callbackDecode finish:", id,info
		ptr = self.picLoads[id].getData()
		if ptr != None:
			for i in self.picLoads[id].indices:
				if not self.picLoads[id].checksum - self.__checksum:
						self.editEntry(i, self.__createEntryList(self.GetList()[i], ptr))
		else:
			mylog(self, self.__callbackDecode.__name__, "ERROR pointer is None!!")
						
		del self.picLoads[id]
		self["ScanPixmap"].setPixmapNum(0)
		self.startPicload()
				
	def historyBack(self):
		self.__callbackMenu((None,7))
		
	def historyNext(self):
		self.__callbackMenu((None,8))

	def KeyMenu(self):
		menu = []
		#if self.__gSoundisRunning == False:
		#	menu.append((_("Rescan Folder"),3))
		#	menu.append((_("Rescan File"),4))
		if self.__randomOn==0:
			menu.append(("%s (%s)" %(_("Play title randomly"),_("enable")),7))
		else:
			menu.append(("%s (%s)" %(_("Play title randomly"),_("disable")),7))
		if self.__loop==0:
			menu.append(("%s (%s)" %(_("Play title as a loop"),_("enable")),8))
		else:
			menu.append(("%s (%s)" %(_("Play title as a loop"),_("disable")),8))
		menu.append(("--", ""))
		menu.append((_("Equalizer"), 9))
		menu.append((_("Setup"),1))
		menu.append((_("Setup Background"), 2))
		menu.append((_("Quickbutton extension"), 5))
		menu.append(("--", ""))
		#Playback on the device
		for x in self.libgtools.getAudioDevice():
			issel=""
			if x[1]==self.__CurrDevice:
				issel="(*) "
			menu.append((_("%sPlayback on device '%s'") %(issel,x[2]), 6, x[1]))
			
		self.Background.lockKeys(True)
		self.session.openWithCallback(self.__callbackMenu, ChoiceBox, title="", keys=[ "1",  "2", "--", "3", "4", "5", "green", "--", "6", "7"], list=menu)
		
	def __callbackMenu(self, what=None):
		self.Background.lockKeys(False)
		if what is None:
			return
		elif what[1] == 1: # Background Settings
			self.Background.lockKeys(True)
			self.session.openWithCallback(self.__readConfig, JukeboxSetup, self.__libjukebox)
		elif what[1] == 2: # Background Settings
			self.Background.lockKeys(True)
			self.session.openWithCallback(self.__callbackConfBackground, confBackground)
		elif what[1] == 3:# Rescan Ordner
			pass
			#self.__startConsole(MI_RESCANDIR,None)
		elif what[1] == 4:# Rescan File
			sel = self.getCurrentEntry()
			if sel and sel[3]:
				pass
				#self.__startConsole(MI_SCANSOUND, sel[3])
		elif what[1] == 5: # Quickbutton
			self.Background.lockKeys(True)
			from Plugins.Bp.geminimain.plugin import InfoBarPlugins
			InfoBarPlugins.quickSelectGlobal(cgevent.InfobarInstance,cgevent.getConfig("Jukebox_Quickbtn", "green_long"), True)
		elif what[1] == 6:
			self.__CurrDevice=what[2]
			if self.__currRunning is not None:
				self.__playFile()
		elif what[1] == 7:
			if self.__randomOn==0:
				self.__randomOn=1
			else:
				self.__randomOn=0
			self["RandomPixmap"].setPixmapNum(self.__randomOn)
			self.__fillListe()
		elif what[1] == 8:
			if self.__loop==0:
				self.__loop=1
			else:
				self.__loop=0
			self["LoopPixmap"].setPixmapNum(self.__loop)
		elif what[1] == 9:
			if self.__useEqualizer==0:
				self.Background.lockKeys(True)
				self.session.openWithCallback(self.__callbackEqualizerMess, MessageBox, _("Use equalizer") + "?", MessageBox.TYPE_YESNO)
			else:
				self.Background.lockKeys(True)
				self.session.openWithCallback(self.__callbackEqualizer, Cequalizer, self.__EqualizerValue, self.__libjukebox)
				
	def __callbackConfBackground(self, *args):
		# always restart to get timers
		self.Background.Exit()
		self.Background = None
		self.Background = self.session.instantiateDialog(WidgetBackground, self)
	
	def __callbackEqualizerMess(self,val=None):
		if val:
			self.__useEqualizer = 1
			cgevent.setConfig("Jukebox_useEqualizer", self.__useEqualizer)
			self.session.openWithCallback(self.__callbackEqualizer, Cequalizer, self.__EqualizerValue, self.__libjukebox)
		else:
			self.Background.lockKeys(False)
			self.__libjukebox.setEqualizer(EqualizerDefaultValue)
			
	def __callbackEqualizer(self,val=None):
		self.Background.lockKeys(False)
		if val is not None:
			self.__EqualizerValue = val
			cgevent.setConfig("Jukebox_Equalizer", self.__EqualizerValue)
			self.__libjukebox.setEqualizer(self.__EqualizerValue)
		
	def __callbackQB(self,val=None):
		self.Background.lockKeys(False)

	def __saveLastPath(self):
		sel = self.getCurrentEntry()
		if sel and sel[3]:
			if sel[3][B_FILTER]  & FILTER_GOUP or self.__Playlisttyp is not None:
				cgevent.setConfig("Jukebox_lastpath", self.path)
			else:
				cgevent.setConfig("Jukebox_lastpath", sel[3][B_FULL])

	def __readConfig(self, reload=False, setup=True):
		if setup:
			self.Background.lockKeys(False)
		self.__cache = False if cgevent.getConfig("Jukebox_cache", 0) == 0 else True
		self.__useInetPicture = cgevent.getConfig("Jukebox_useInetPicture", 1)
		self.__timeInvers = cgevent.getConfig("Jukebox_timeInvers", 0)
		self.__jumptime = cgevent.getConfig("Jukebox_jumptime", 5)
		self.__useEqualizer = cgevent.getConfig("Jukebox_useEqualizer", 0)
		self.__EqualizerValue = cgevent.getConfig("Jukebox_Equalizer", EqualizerDefaultValue)
		
		
		if reload:
			self.__fillListe()
		
#-------------------------------------------------------------------------------------

	def KeyOk(self):
		#print "______________KeyOk self.shown",self.shown
		if self.shown:
			sel = self.getCurrentEntry()
			if sel and sel[3]:
				if sel[3][B_FILTER] & FILTER_DIR:
					self.lastpath = self.path
					self.__Playlisttyp = None
					self.path = sel[3][B_FULL]
					self.__fillListe()
				elif sel[3][B_FILTER] & FILTER_PL:
					self.lastpath = self.path
					self.__Playlisttyp = sel[3][B_EXT]
					self.path = sel[3][B_FULL]
					self.__fillListe()
				elif sel[3][B_FILTER] & FILTER_SOUND:
					self.__playFile(True)

	def KeyGreen(self):
		if self.__currRunning is not None:
			if self.__currRunning != self.getCurrentEntry():
				self.KeyOk()
		else:
			self.KeyOk()

	def KeyYellow(self):
		self.__libjukebox.pause()

	def KeyRed(self):
		self.KeyPrev()

	def KeyPrev(self):
		if self.__libjukebox.isSeeking()>0:
			self.__libjukebox.seek("0")
		else:
			self.__libjukebox.seek(str(-self.__jumptime))
		
	def KeyBlue(self):
		self.KeyNext()

	def KeyNext(self):
		if self.__libjukebox.isSeeking()>0:
			self.__libjukebox.seek("0")
		else:
			self.__libjukebox.seek(str(self.__jumptime))

	def nextTitle(self):
		self.__firstTitle = ""
		self.__testTitle = self.getCurrentEntry()
		self.__NextTitle()
		
	def __NextTitle(self):
		WidgetVariableList.KeyDown(self)
		sel = self.getCurrentEntry()
		if sel and sel[3]:
			if sel[3][B_FILTER] & FILTER_SOUND:
				self.__playFile()
			else:
				#if len(self.GetList())>2:
				if sel == self.__testTitle:
					self.__stopFile()
				else:
					self.__NextTitle()
	
	def prevTitle(self):
		self.__firstTitle = ""
		self.__testTitle = self.getCurrentEntry()
		self.__PrevTitle()
		
	def __PrevTitle(self):
		WidgetVariableList.KeyUp(self)
		sel = self.getCurrentEntry()
		if sel and sel[3]:
			if sel[3][B_FILTER] & FILTER_SOUND:
				self.__playFile()
			else:
				if len(self.GetList())>2:
					if sel == self.__testTitle:
						self.__stopFile()
					else:
						self.__PrevTitle()

	def __playFile(self, setFirstTitle=False):
		sel = self.getCurrentEntry()
		if sel and sel[3]:
			if self.__firstTitle == sel[3][B_FULL] and self.__loop < 1:
				#print "f=c_________________________________________"
				self.__libjukebox.stop()#Stopp erster Titel erreicht
				self.__firstTitle = ""
				self.__stopFile()
				return
			
			if setFirstTitle:
				self.__firstTitle = sel[3][B_FULL]

			self.__currRunning = sel[:]
			self.__setNameStr()
			
			notdmmalsa = int(self.__CurrDevice != self.__DMMAlsaDevice)
			self.__libjukebox.start([sel[3][B_FULL], self.__CurrDevice, notdmmalsa, self.__EqualizerValue])

	def __stopFile(self):
		self.__currRunning = None
		self["StatusPixmap"].setPixmapNum(self.STAT_STOP)
		self["Progress"].setValue(0)
		self["TimeStr"].setText("")
		self["NameStr"].setText("")

	def __setNameStr(self):
		if self.__currRunning is not None:
			text=self.__currRunning[3][B_NAME]
			if len(self.__currRunning[4])==7 and self.__currRunning[4][SOUND_TITLE] is not "":
				text = self.__currRunning[4][SOUND_TITLE]
				if self.__currRunning[4][SOUND_ARTIST] is not "":
					text += " - " + self.__currRunning[4][SOUND_ARTIST]
			self["NameStr"].setText(text)
		
#---------------------------------------------------------------------

#	def __startConsole(self, func, file):
#		if self.__gSoundisRunning == False:
#			cmd=None
#			if func==MI_SCANDIR or func==MI_RESCANDIR:
#				cmd = "%s '%s' '%s' %d %d '%s'" %(self.GMEDIASCAN, self.path, "/root/.geminicache", self.__useInetPicture, func, "all")
#			elif func==MI_SCANSOUND:
#				cmd = "%s '%s' '%s' %d %d '%s'" %(self.GMEDIASCAN, file[B_NAME], file[B_CFILE], self.__useInetPicture, func, " ")
#			elif func==MI_SCANPLAYLIST:
#				cmd = "%s '%s' '%s' %d %d '%s'" %(self.GMEDIASCAN, self.lastpath, "/root/.geminicache", self.__useInetPicture, func, self.path)
#				
#			if cmd:
#				self.__gSoundisRunning = True
#				self["ScanPixmap"].setPixmapNum(1)
#				self.Console.ePopen(cmd, self.__FinishedConsole)
#			
#	def __FinishedConsole(self, result, retval, extra_args = None):
#		self.__gSoundisRunning = False
#		self["ScanPixmap"].setPixmapNum(0)
#		
	
#---------------------------------------------------------------------------------------------

class JukeboxSetup(gConfigWindow):
	def __init__(self, session, libjukebox):
		self.__libjukebox = libjukebox
		self.Console = Console()
		qbsmenu = [('red', _('red')), ('red_long', _('red') + ' ' + _('long')), ('green', _('green')), ('green_long', _('green') + ' ' + _('long')), ('yellow', _('yellow')), ('yellow_long', _('yellow') + ' ' + _('long')), ('blue', _('blue')), ('blue_long', _('blue') + ' ' + _('long')), ('console', _('CONSOLE (DMM Kbd)')), ('f1', _('F1 (DMM Kbd) / F2 (Kbd)')), ('f2', _('F2 (DMM Kbd) / F3 (Kbd)')), ('web', _('WEB (DMM Kbd) / F6 (Kbd)')), ('mail', _('MAIL (DMM Kbd) / / F7 (Kbd)')), ('pvr', _('PVR / Video / F8 (Kbd)')), ( 'pvr_long', _('PVR / Video / F8 (Kbd)') + ' ' + _('long')), ('radio', _('RADIO / F9 (Kbd)')), ('radio_long', _('RADIO / F9 (Kbd)') + ' ' + _('long')), ('m1', _('M1 (DMM Kbd) / F11 (Kbd)')), ('m2', _('M2 (DMM Kbd) / F10 (Kbd)')), ('text', _('TEXT')), ('text_long', _('TEXT') + ' ' + _('long')), ('help_long', _('HELP') + ' ' + _('long')), ('info', _('INFO')), ('info_long', _('INFO') + ' ' + _('long'))]
		
		from Plugins.Bp.geminimain.plugin import cgevent
		config.bp.quickbtn = NoSave(gConfigSelection(default=str(cgevent.getConfig("Jukebox_Quickbtn", "green_long")), choices=qbsmenu))
		config.bp.inetpic = NoSave(gConfigOnOff(default=cgevent.getConfig("Jukebox_useInetPicture", 1)))
		config.bp.timeInvers = NoSave(gConfigOnOff(default=cgevent.getConfig("Jukebox_timeInvers", 0)))
		config.bp.equalizer = NoSave(gConfigOnOff(default=cgevent.getConfig("Jukebox_useEqualizer", 0)))
		config.bp.jumptime = NoSave(ConfigInteger(default=cgevent.getConfig("Jukebox_jumptime", 5), limits = [2,99]))
		config.bp.sort = NoSave(gConfigSelection(default=cgevent.getConfig("Jukebox_sort", SORT_NAME), choices=sortmenu + soundmenu))
		config.bp.homedir = NoSave(gConfigDirectory(default=cgevent.getConfig("Jukebox_StartDir"," "), visible_width=35))
		config.bp.cache = NoSave(gConfigOnOff(default=cgevent.getConfig("Jukebox_cache", 0)))
		
		self.__EqualizerValue = config.bp.equalizer.value
		self.__sort = config.bp.sort.value
		self.__inet = config.bp.inetpic.value
		
		list=[]
		list.append(getConfigListEntry(_("Sort by"), config.bp.sort))
		list.append(getConfigListEntry(_("Use equalizer"), config.bp.equalizer))
		list.append(getConfigListEntry(_("Downloading cover from Internet"), config.bp.inetpic))
		list.append(getConfigListEntry(_("Image Cache"), config.bp.cache))
		list.append(getConfigListEntry(_("Show time inverted"), config.bp.timeInvers))
		list.append(getConfigListEntry(_("Skip ? seconds"), config.bp.jumptime))
		list.append(getConfigListEntry(_("Home Directory"), config.bp.homedir))
		list.append(CONFIGSEPERATOR())
		list.append(getConfigListEntry(_("Quickbutton extension in Menu"), config.bp.quickbtn))
		
		gConfigWindow.__init__(self, session,list=list)
		
	def SelectionChangedNow(self):
		sel = self.getCurrendValue()
		if sel == config.bp.homedir:
			self.setRB(_("Delete"))
		elif sel == config.bp.cache:
			self.setRB(_("Delete"))
		else:
			self.setRB()
			
	def KeyRed(self):
		sel = self.getCurrendValue()
		if sel == config.bp.homedir:
			config.bp.homedir.setValue(" ")
			gConfigWindow.KeyUp(self)
			gConfigWindow.KeyDown(self)
			
		elif sel == config.bp.cache:
			from FileBrowser import gBrowser
			self.session.openWithCallback(self.__cleanCacheCallback, gBrowser, setPath=cgevent.getConfig("Jukebox_cache_path", "/media/") , filter=FILTER_DIR)
			
	def __cleanCacheCallback(self, dir=None, *args):
		if dir is None:
			return
		
		cgevent.setConfig("Jukebox_cache_path", dir)
		gpu_cache=[os_path.join(root,d) for root,dirs,fs in os_walk(dir) for d in dirs if d.endswith(".Thumbnails")]
		cmd=""
		for x in gpu_cache:
			if cmd!="":
				cmd += " && "
			cmd += "rm -rf '%s" %x
		self.Console.ePopen(cmd, self.__FinishedConsole)
		
	def __FinishedConsole(self, result, retval, extra_args = None):
		self.session.open(MessageBox, _("done..."), MessageBox.TYPE_INFO, timeout=3)
		
	def KeyGreen(self):
		if self.__EqualizerValue != config.bp.equalizer.value:
			cgevent.setConfig("Jukebox_useEqualizer", config.bp.equalizer.value)
			if self.__EqualizerValue:
				self.__libjukebox.setEqualizer(cgevent.getConfig("Jukebox_Equalizer", EqualizerDefaultValue))
			else:
				self.__libjukebox.setEqualizer(EqualizerDefaultValue)
		
		cgevent.setConfig("Jukebox_Quickbtn", config.bp.quickbtn.value)
		cgevent.setConfig("Jukebox_useInetPicture", config.bp.inetpic.value)
		cgevent.setConfig("Jukebox_timeInvers", config.bp.timeInvers.value)
		cgevent.setConfig("Jukebox_jumptime", config.bp.jumptime.value)
		cgevent.setConfig("Jukebox_StartDir", config.bp.homedir.value)
		cgevent.setConfig("Jukebox_sort",config.bp.sort.value)
		cgevent.setConfig("Jukebox_cache", config.bp.cache.value)
		
		if self.__sort != config.bp.sort.value or self.__inet != config.bp.inetpic.value:
			self.KeyExit(True)
		else:
			self.KeyExit()

	def KeyExit(self, val=False):
		self.Console.killAll()
		del self.Console
		self.close(val)
